_G.BlackList = _G.BlackList or {}

if RequiredScript == "lib/managers/menumanager" then
	function MenuManager:open_blacklist_menu()
		if managers.network and managers.network:session() then			
			managers.menu_component:post_event("menu_enter")			
			if not SimpleMenu then
				SimpleMenu = class()	
				
				function SimpleMenu:init(title, message, options)
					self.dialog_data = { title = title, text = message, button_list = {},
						id = tostring(math.random(0,0xFFFFFFFF)) }
					self.visible = false
					for _,opt in ipairs(options) do
						local elem = {}
						elem.text = opt.text
						opt.data = opt.data or nil
						opt.callback = opt.callback or nil
						elem.callback_func = callback(self, self, "_do_callback",
									  { data = opt.data,
										callback = opt.callback})
						elem.cancel_button = opt.is_cancel_button or false
						if opt.is_focused_button then
						self.dialog_data.focus_button = #self.dialog_data.button_list+1
						end
						table.insert(self.dialog_data.button_list, elem)
					end
					return self
				end
			 
				function SimpleMenu:_do_callback(info)
					if info.callback then
						if info.data then
						info.callback(info.data)
						else
						info.callback()
						end
					end
					self.visible = false
				end
			 
				function SimpleMenu:show()
					if self.visible then
						return
					end
					self.visible = true
					managers.system_menu:show(self.dialog_data)
				end
			 
				function SimpleMenu:hide()
					if self.visible then
						managers.system_menu:close(self.dialog_data.id)
						self.visible = false
						return
					end
				end
			end 

			optionone = optionone or function(data)
				managers.menu_component:post_event("menu_enter")
				BlackList:WriteIntoList(data)
			end

			optionnext1 = optionnext1 or function()
				managers.menu_component:post_event("menu_enter")
				createmenu(1)
			end

			function createmenu(var)
				local opts = {}
				local _txt = ""
				for i = 1, 4 do
					if var == 0 then
						local peer = managers.network:session():peer(i) or nil
						if peer and peer ~= managers.network:session():local_peer() then
							_txt = peer:name() .. " (" .. peer:user_id() .. ")"
							opts[#opts+1] = { text = "" .. _txt, data = tostring(peer:user_id()), callback = optionone }
						end
					elseif var == 1 then
						if BlackList.Old_Name[i] and BlackList.Old_Steam[i] then
							_txt = BlackList.Old_Name[i] .. " (" .. BlackList.Old_Steam[i] .. ")"
							opts[#opts+1] = { text = "" .. _txt, data = tostring(BlackList.Old_Steam[i]), callback = optionone }
						end
					end
				end

				opts[#opts+1] = { text = "History", data = 0, callback = optionnext1 }
				opts[#opts+1] = { text = "CANCEL", is_cancel_button = true }
				mymenu = SimpleMenu:new("Ban Menu", "Ban someone you don't like.", opts)
				mymenu:show()
			end
			createmenu(0)
		end
	end
end

if managers.menu then
	BlackList:Record_All()
	managers.menu:open_blacklist_menu()
end